
local Mounted = Mounted
Mounted.modules = Mounted.modules or {}
Mounted.modules.DRUID = CreateFrame("frame")
local DRUID = Mounted.modules.DRUID
local OnUpdate = function(self, ...) if self['MoveCheck'] then return self['MoveCheck'](self, ...) end end

-- nils out tables and subtables so nothing is left at the end
local function DelTable(t)
	setmetatable(t, nil)
	for k in pairs(t) do
		if type(t[k]) == "table" then
			DelTable(t[k])
		end
		t[k] = nil
	end
	return nil
end

function DRUID:LoadModule()
	local _, class = UnitClass("player")
	if class ~= 'DRUID' then
		OnUpdate = nil
		Mounted.modules.DRUID = DelTable(Mounted.modules.DRUID)
		return
	end
	Mounted.spellmounts = Mounted.spellmounts or {}
	Mounted.spellmounts[40120] = 'f,280' --swift flight
	Mounted.spellmounts[33943] = 'f,60' --flight
	Mounted.spellmounts[783] = 'g,40' --travel
	Mounted.spellmounts[768] = 'a,a' --cat
	Mounted.spellmounts[1066] = 'a,a' --aquatic
	
	-- add druid module defaults the enable switch should be per character
	Mounted.defaults.char.Module.DRUID = {
		['swim'] = true,
		['move'] = true,
		['cat'] = true,
	}
	DRUID:SetScript("OnUpdate", OnUpdate)
	DRUID:RegisterEvent("PLAYER_REGEN_DISABLED")
	DRUID:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
end

function DRUID:PLAYER_REGEN_DISABLED()
	DRUID.isMoving = false
end

function DRUID:LEARNED_SPELL_IN_TAB()
	if Mounted.db.char.mounts['f']['280'][40120] then
		Mounted.db.char.mounts['f']['60'][33943] = nil
		Mounted.spellmounts[33943] = nil
	end
end

function DRUID:UNIT_SPELLCAST_SUCCEEDED(event, arg1, arg2)
	if arg1 == 'player' and (arg2 == GetSpellInfo(40120) or arg2 == GetSpellInfo(33943) or arg2 == GetSpellInfo(783))then
		Mounted:SelectMacro(true)
	end
end

function DRUID:SPELL_UPDATE_USABLE() -- gets called with from mounted lua
	DRUID.isMoving = false
end

DRUID.isMoving = false
local isSwimmingOld = false
function DRUID:MoveCheck()
	if not InCombatLockdown() then
		if Mounted.db.char.Module.DRUID.swim then
			if not isSwimmingOld and (IsSwimming() and Mounted.db.char.mounts['a']['a'][1066]) then
				isSwimmingOld = true
				return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(1066)))
			elseif isSwimmingOld and not (IsSwimming() and Mounted.db.char.mounts['a']['a'][1066]) then
				isSwimmingOld = false
				DRUID.isMoving = false
				Mounted:SelectMacro(true)
			end
		end
		if Mounted.db.char.Module.DRUID.move then
			if GetUnitSpeed('player') ~= 0 and not IsSwimming() then
				if not DRUID.isMoving then
					DRUID.isMoving = true
					if Mounted:CustIsFlyable() then
						if Mounted.db.char.mounts['f']['280'][40120] then
							local f = GetSpellInfo(40120)
							local g = GetSpellInfo(783)
							return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast [nomodifier] %s; %s', f, g))
						elseif Mounted.db.char.mounts['f']['60'][33943] then
							local f = GetSpellInfo(33943)
							local g = GetSpellInfo(783)
							return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast [nomodifier] %s; %s', f, g))
						elseif Mounted.db.char.mounts['g']['40'][783] then
							return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(783)))
						elseif Mounted.db.char.Module.DRUID.cat and Mounted.db.char.mounts['a']['a'][768] then
							return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(768)))
						end
					elseif IsOutdoors() and Mounted.db.char.mounts['g']['40'][783] then
						if Mounted.db.char.mounts['g']['40'][783] then
							return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(783)))
						elseif Mounted.db.char.Module.DRUID.cat and Mounted.db.char.mounts['a']['a'][768] then
							return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(768)))
						end
					elseif Mounted.db.char.Module.DRUID.cat and not IsOutdoors() and Mounted.db.char.mounts['g']['40'][783] then
						return EditMacro(GetMacroIndexByName("Mounted"), "Mounted", 1, string.format('#showtooltip\n/cast %s()', GetSpellInfo(768)))
					end
				end
			elseif not IsSwimming() then
				if DRUID.isMoving then
					DRUID.isMoving = false
					Mounted:SelectMacro(true)
				end
			end
		end
	end
end
